var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createHandler: () => createHandler,
  dataProvider: () => dataProvider,
  defaultHandler: () => defaultHandler,
  deleteHandler: () => deleteHandler,
  deleteManyHandler: () => deleteManyHandler,
  extractOrderBy: () => extractOrderBy,
  extractSkipTake: () => extractSkipTake,
  extractWhere: () => extractWhere,
  getListHandler: () => getListHandler,
  getManyHandler: () => getManyHandler,
  getManyReferenceHandler: () => getManyReferenceHandler,
  getOneHandler: () => getOneHandler,
  updateHandler: () => updateHandler
});
module.exports = __toCommonJS(src_exports);

// src/audit/types.ts
var defaultAuditOptions = {
  columns: {
    id: "id",
    date: "date",
    resource: "resource",
    action: "action",
    payload: "payload",
    author: "author"
  },
  enabledForAction: {
    create: true,
    update: true,
    delete: true
  }
};

// src/audit/auditHandler.ts
var auditHandler = async (request, options, created) => {
  const action = request.body.method.split(/(?=[A-Z])/)[0];
  const mergedOptions = __spreadValues(__spreadValues({}, defaultAuditOptions), options);
  if (action === "get") {
    return;
  }
  if (request.body.method === "updateMany" || request.body.method === "deleteMany") {
    for (const id of request.body.params.ids) {
      await createAuditEntry(mergedOptions, request, id);
    }
  } else if ("id" in request.body.params) {
    await createAuditEntry(mergedOptions, request, request.body.params.id);
  } else if (created) {
    await createAuditEntry(mergedOptions, request, created.id);
  }
  return true;
};
var createAuditEntry = async (options, request, id) => {
  let payload = {
    id: id.toString()
  };
  const user = await options.authProvider.getIdentity();
  let data = {
    [options.columns.action]: request.body.method.split(/(?=[A-Z])/)[0],
    [options.columns.resource]: request.body.resource,
    [options.columns.payload]: payload,
    [options.columns.author]: {
      connect: { id: user.id }
    }
  };
  const created = await options.model.create({
    data
  });
  return created;
};

// src/createHandler.ts
var createHandler = async (req, res, table, options, audit) => {
  const { data } = req.body.params;
  Object.entries(data).forEach(([prop, value]) => {
    if (value === "") {
      delete data[prop];
    }
  });
  Object.entries(data).forEach(([prop, value]) => {
    var _a;
    const foreignConnectKey = (_a = options == null ? void 0 : options.connect) == null ? void 0 : _a[prop];
    if (foreignConnectKey) {
      data[prop] = {
        connect: Array.isArray(value) ? value.map((key) => ({ [foreignConnectKey]: key })) : { [foreignConnectKey]: value }
      };
    }
  });
  const created = await table.create({
    data
  });
  if (audit) {
    await auditHandler(req, audit, created);
  }
  res.json({ data: created });
};

// src/lib/isNumericId.ts
var isNumericId = (id) => /^\d+$/.test(id);

// src/dataProvider.ts
var import_axios = __toESM(require("axios"));
var dataProvider = (endpoint, options) => {
  const apiService = import_axios.default.create({
    baseURL: endpoint
  });
  apiService.interceptors.response.use((res) => res.data);
  if (options == null ? void 0 : options.axiosInterceptors) {
    if (options.axiosInterceptors.request)
      options.axiosInterceptors.request.forEach((value) => apiService.interceptors.request.use(value.onFulfilled, value.onRejected, value.options));
    if (options.axiosInterceptors.response)
      options.axiosInterceptors.response.forEach((value) => apiService.interceptors.response.use(value.onFulfilled, value.onRejected, value.options));
  }
  return {
    getList: (resource, params) => {
      var _a, _b;
      return apiService.post(resource, {
        method: "getList",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    getOne: (resource, params) => {
      var _a, _b;
      castIdToOriginalType(params);
      return apiService.post(resource, {
        method: "getOne",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    getMany: (resource, params) => {
      var _a, _b;
      return apiService.post(resource, {
        method: "getMany",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    getManyReference: (resource, params) => {
      var _a, _b;
      return apiService.post(resource, {
        method: "getManyReference",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    create: (resource, params) => {
      var _a, _b;
      return apiService.post(resource, {
        method: "create",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    update: (resource, params) => {
      var _a, _b;
      castIdToOriginalType(params);
      return apiService.post(resource, {
        method: "update",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    updateMany: (resource, params) => {
      var _a, _b;
      return apiService.post(resource, {
        method: "updateMany",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    delete: (resource, params) => {
      var _a, _b;
      castIdToOriginalType(params);
      return apiService.post(resource, {
        method: "delete",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    },
    deleteMany: (resource, params) => {
      var _a, _b;
      return apiService.post(resource, {
        method: "deleteMany",
        resource,
        params,
        model: (_b = (_a = options == null ? void 0 : options.resourceToModelMap) == null ? void 0 : _a[resource]) != null ? _b : void 0
      }).catch(reactAdminAxiosErrorHandler);
    }
  };
};
var castIdToOriginalType = (params) => {
  if (isNumericId(params.id))
    params.id = +params.id;
};
var reactAdminAxiosErrorHandler = (error) => {
  var _a;
  throw (_a = error == null ? void 0 : error.response) == null ? void 0 : _a.data;
};

// src/deleteHandler.ts
var deleteHandler = async (req, res, table, options, audit) => {
  const { id } = req.body.params;
  const deleted = (options == null ? void 0 : options.softDeleteField) ? await table.update({
    where: { id },
    data: {
      [options == null ? void 0 : options.softDeleteField]: new Date()
    }
  }) : await table.delete({
    where: { id }
  });
  if (audit) {
    await auditHandler(req, audit);
  }
  res.json({ data: deleted });
};

// src/extractOrderBy.ts
var import_set_value = __toESM(require("set-value"));
var extractOrderBy = (req) => {
  const { sort } = req.body.params;
  let orderBy = {};
  if (sort) {
    const { field, order } = sort;
    if (field && order) {
      (0, import_set_value.default)(orderBy, field, order.toLowerCase());
    }
  }
  return orderBy;
};

// src/extractSkipTake.ts
var extractSkipTake = (req) => {
  const { pagination } = req.body.params;
  let skip;
  let take;
  if (pagination) {
    const { page, perPage } = pagination;
    const first = (page - 1) * perPage;
    const last = page * perPage - 1;
    if (first === 0 && last === 999) {
    } else {
      skip = first;
      take = last - first + 1;
    }
  }
  return { skip, take };
};

// src/lib/isNotField.ts
var isNotField = (fieldName) => {
  if (fieldName.startsWith("_"))
    return true;
  return false;
};

// src/lib/isObject.ts
var isObject = (arg) => Object.prototype.toString.call(arg) === "[object Object]";

// src/extractWhere.ts
var import_set_value2 = __toESM(require("set-value"));
var logicalOperators = ["gte", "lte", "lt", "gt"];
var extractWhere = (req) => {
  const { filter } = req.body.params;
  const where = {};
  if (filter) {
    Object.entries(filter).forEach(([colName, value]) => {
      if (isNotField(colName))
        return;
      if (value === "")
        return;
      const hasOperator = logicalOperators.some((operator) => {
        if (colName.endsWith(`_${operator}`)) {
          [colName] = colName.split(`_${operator}`);
          (0, import_set_value2.default)(where, colName, { [operator]: value }, { merge: true });
          return true;
        }
      });
      if (hasOperator)
        return;
      if (colName === "q") {
      } else if (colName === "id" || colName === "uuid" || colName === "cuid" || colName.endsWith("_id") || typeof value === "number" || typeof value === "boolean") {
        (0, import_set_value2.default)(where, colName, value);
      } else if (Array.isArray(value)) {
        (0, import_set_value2.default)(where, colName, { in: value });
      } else if (typeof value === "string") {
        (0, import_set_value2.default)(where, colName, { contains: value, mode: "insensitive" });
      } else if (isObject(value)) {
        const { path, equals } = getPostgresJsonFilter(value);
        if (path.length && equals) {
          (0, import_set_value2.default)(where, colName, { path, equals });
        }
      } else {
        console.info("Filter not handled:", colName, value);
      }
    });
  }
  return where;
};
var getPostgresJsonFilter = (obj) => {
  const path = Object.keys(obj);
  const val = obj[path[0]];
  let equals;
  if (isObject(val)) {
    const { path: returnedPath, equals: returnedEquals } = getPostgresJsonFilter(val);
    equals = returnedEquals;
    path.push(...returnedPath);
  } else {
    equals = val;
  }
  return { path, equals };
};

// src/getListHandler.ts
var getListHandler = async (req, res, table, options) => {
  var _a, _b, _c, _d, _e, _f;
  const { pagination, sort, filter } = req.body.params;
  let queryArgs = {
    findManyArg: {
      select: (_a = options == null ? void 0 : options.select) != null ? _a : void 0,
      include: (_b = options == null ? void 0 : options.include) != null ? _b : void 0,
      where: (_c = options == null ? void 0 : options.where) != null ? _c : {}
    },
    countArg: {
      where: (_d = options == null ? void 0 : options.where) != null ? _d : {}
    }
  };
  if (!table)
    throw new Error(`missing table in getListHandler`);
  const where = extractWhere(req);
  if (options == null ? void 0 : options.debug) {
    console.log("getListHandler:where", JSON.stringify(where, null, 2));
  }
  queryArgs.findManyArg.where = __spreadValues(__spreadValues({}, queryArgs.findManyArg.where), where);
  queryArgs.countArg.where = __spreadValues(__spreadValues({}, queryArgs.countArg.where), where);
  const { skip, take } = extractSkipTake(req);
  queryArgs.findManyArg.skip = skip;
  queryArgs.findManyArg.take = take;
  if (sort) {
    queryArgs.findManyArg.orderBy = extractOrderBy(req);
    const { field } = sort;
    if (field && ((_e = options == null ? void 0 : options.noNullsOnSort) == null ? void 0 : _e.includes(field))) {
      queryArgs.findManyArg.where = { [field]: { not: null } };
      queryArgs.countArg.where = { [field]: { not: null } };
    }
  }
  if (options == null ? void 0 : options.debug) {
    console.log("getListHandler:queryArgs", JSON.stringify(queryArgs, null, 2));
  }
  const [data, total] = await Promise.all([
    table.findMany(queryArgs.findManyArg),
    table.count(queryArgs.countArg)
  ]);
  await ((_f = options == null ? void 0 : options.transform) == null ? void 0 : _f.call(options, data));
  res.json({
    data,
    total
  });
};

// src/updateHandler.ts
var updateHandler = async (req, res, model, options, audit) => {
  const { id } = req.body.params;
  const data = Object.entries(req.body.params.data).reduce((fields, [key, value]) => {
    var _a, _b, _c, _d;
    if (isNotField(key))
      return fields;
    if ((_a = options == null ? void 0 : options.skipFields) == null ? void 0 : _a[key])
      return fields;
    if (Array.isArray(value)) {
      const foreignConnectKey = (_b = options == null ? void 0 : options.set) == null ? void 0 : _b[key];
      if (foreignConnectKey) {
        fields[key] = {
          set: value.map((value2) => ({ [foreignConnectKey]: value2 }))
        };
      }
    } else if (isObject(value)) {
      if ((_c = options == null ? void 0 : options.allowNestedUpdate) == null ? void 0 : _c[key]) {
        fields[key] = {
          update: {
            data: value
          }
        };
      }
      if ((_d = options == null ? void 0 : options.allowNestedUpsert) == null ? void 0 : _d[key]) {
        fields[key] = {
          upsert: {
            create: value,
            update: value
          }
        };
      }
    } else {
      fields[key] = value;
    }
    return fields;
  }, {});
  if (options == null ? void 0 : options.debug) {
    console.log("updateHandler:data", data);
  }
  const updated = await model.update({
    where: { id },
    data
  });
  if (audit) {
    await auditHandler(req, audit);
  }
  res.json({ data: updated });
};

// src/deleteManyHandler.ts
var deleteManyHandler = async (req, res, table, options, audit) => {
  const { ids } = req.body.params;
  const deleted = (options == null ? void 0 : options.softDeleteField) ? await table.updateMany({
    where: { id: { in: ids } },
    data: {
      [options == null ? void 0 : options.softDeleteField]: new Date()
    }
  }) : await table.deleteMany({
    where: { id: { in: ids } }
  });
  if (audit) {
    await auditHandler(req, audit);
  }
  res.json({ data: ids });
};

// src/getManyHandler.ts
var getManyHandler = async (req, res, table) => {
  const { ids } = req.body.params;
  const list = await table.findMany({
    where: { id: { in: ids } }
  });
  res.json({ data: list });
};

// src/getManyReferenceHandler.ts
var getManyReferenceHandler = async (req, res, table) => {
  const { id, target } = req.body.params;
  const orderBy = extractOrderBy(req);
  const where = extractWhere(req);
  const { skip, take } = extractSkipTake(req);
  const list = await table.findMany({
    where: __spreadValues({ [target]: id }, where),
    orderBy,
    skip,
    take
  });
  res.json({ data: list, total: list.length });
};

// src/getOneHandler.ts
var getOneHandler = async (req, res, model, options) => {
  var _a, _b, _c;
  const { id } = req.body.params;
  const row = await model.findUnique({
    where: { id },
    select: (_a = options == null ? void 0 : options.select) != null ? _a : void 0,
    include: (_b = options == null ? void 0 : options.include) != null ? _b : void 0
  });
  if (options == null ? void 0 : options.debug)
    console.log("getOneHandler:beforeTransform", row);
  await ((_c = options == null ? void 0 : options.transform) == null ? void 0 : _c.call(options, row));
  if (options == null ? void 0 : options.debug)
    console.log("getOneHandler:afterTransform", row);
  res.json({ data: row });
};

// src/defaultHandler.ts
var defaultHandler = async (req, res, prisma, options) => {
  const modelName = req.body.model || req.body.resource;
  if (!modelName)
    throw new Error(`model name is empty`);
  const model = prisma[modelName];
  if (!model)
    throw new Error(`No model found for "${modelName}"`);
  switch (req.body.method) {
    case "getList": {
      return getListHandler(req, res, model, options == null ? void 0 : options.getList);
    }
    case "getOne": {
      return getOneHandler(req, res, model);
    }
    case "getMany": {
      return getManyHandler(req, res, model);
    }
    case "getManyReference": {
      return getManyReferenceHandler(req, res, model);
    }
    case "create": {
      return await createHandler(req, res, model, void 0, options == null ? void 0 : options.audit);
    }
    case "update": {
      return await updateHandler(req, res, model, options == null ? void 0 : options.update, options == null ? void 0 : options.audit);
    }
    case "delete": {
      return await deleteHandler(req, res, model, options == null ? void 0 : options.delete, options == null ? void 0 : options.audit);
    }
    case "deleteMany": {
      return deleteManyHandler(req, res, model, options == null ? void 0 : options.delete, options == null ? void 0 : options.audit);
    }
    default:
      throw new Error("Invalid method");
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createHandler,
  dataProvider,
  defaultHandler,
  deleteHandler,
  deleteManyHandler,
  extractOrderBy,
  extractSkipTake,
  extractWhere,
  getListHandler,
  getManyHandler,
  getManyReferenceHandler,
  getOneHandler,
  updateHandler
});
